/**
 * app.js
 */

var path = require('path'),
    fs = require('fs');

var xbox = require('./xbox');
var gamertags = ['Maaem', 'ReerNakedChoke', 'Krizman79', 'GeekEleet'];

function cardExists(gamertag, callback) {
  var filename = './gamercards/' + gamertag + '.json';
  path.exists(filename, function(exists) {
    callback(filename, exists);
  });
}

function loadCardHistory(filename, callback) {
  fs.readFile(filename, 'utf8', function(err, data) {
    if (err) throw err;

    var cardHistory = JSON.parse(data);
    callback(cardHistory);
  });
}

function saveCardHistory(cardHistory, filename) {
  cardHistory.accurateAsOf = Date();
  fs.writeFile(filename, JSON.stringify(cardHistory));
}

gamertags.forEach(function(gamertag) {
  new xbox.Browser(gamertag, function(card) {
    console.log(gamertag);
    console.log(card.gamerscore);

    cardExists(gamertag, function(filename, exists) {
      if (!exists) {
        //var cardHistory.gamertag = gamertag;
        cardHistory.cards = new Array(card);
        saveCardHistory(cardHistory, filename);
      } else {
        loadCardHistory(filename, function(cardHistory) {
          var lastCard = cardHistory.cards[cardHistory.cards.length - 1];
          if (parseInt(lastCard.gamerscore) < parseInt(card.gamerscore)) {
            cardHistory.cards.push(card);
          }
          saveCardHistory(cardHistory, filename);
        });
      }
    });
  });
});
