/**
 * arstechnica.js
 */

var castaneum = require('castaneum');

var Browser = exports.Browser = function(gamertag, callback) {
  var that = this;
  var uri = 'http://gamercard.xbox.com/' + gamertag + '.card';
  castaneum.get(uri, function(error, response, body) {
    castaneum.createDocument(response, function(document, sizzle) {
      that.title = document.title;
      that.location = document.location;

      // build up a card "object"
      var card = {};
      card.createdAt = Date();
      card.gamertileUrl = sizzle('.XbcgcGamertile')[0].src;
      card.repstarsUrl = sizzle('.XbcFRAR img')[0].src;
      card.gamerscore = sizzle('.XbcFRAR')[1].textContent.trim();
      card.zone = sizzle('.XbcFRAR')[2].textContent.trim();
      card.recentGames = [];
      sizzle('.XbcgcGames img').forEach(function(el) {
        var game = {};
        game.title = el.attributes._nodes['title']._nodeValue;
        game.gametileUrl = el.src;
        card.recentGames.push(game);
      });

      callback(card);
    });
  });
};
