var sys = require('sys'),
    events = require('events');

var castaneum = require('castaneum');
var testCase = require('nodeunit').testCase;

exports.headRemote = function(test) {
  castaneum.head('http://www.google.ca/', function(error, response, body) {
    test.equal(body.length, 0);
    test.done();
  });
};
exports.headLocal = function(test) {
  castaneum.head('./test/data/www.google.ca_index.html', function(error, response, body) {
    test.equal(body.length, 0);
    test.done();
  });
};
exports.getRemote = function(test) {
  castaneum.get('http://www.google.ca/', function(error, response, body) {
    test.notEqual(body.length, 0);
    test.done();
  });
};
exports.getLocal = function(test) {
  castaneum.get('./test/data/www.google.ca_index.html', function(error, response, body) {
    test.notEqual(body.length, 0);
    test.done();
  });
};
exports.putLocal = function(test) {
  castaneum.get('http://www.google.ca/', function(error, response, body) {
    var uri = './test/data/' + Math.random() + '.html';
    require('path').exists(uri, function(exists) {
      test.equal(exists, false);
      castaneum.put(uri, body, function(error) {
        require('path').exists(uri, function(exists) {
          test.equal(exists, true);
          test.done();
        });
      }); 
    });
  });
};
exports.documentAttributes = function(test) {
  var uri = './test/data/www.google.ca_index.html';
  castaneum.get(uri, function(error, response, body) {
    castaneum.createDocument(response, function(document, sizzle) {
      test.notEqual(document, undefined);
      test.equal(document.title, 'Google');
      test.equal(document.location, uri);
      test.notEqual(sizzle, undefined);
      test.done();
    });
  });
};
exports.ajaxianPosts = function(test) {
  var uri = './test/data/ajaxian.com_index.html';
  castaneum.get(uri, function(error, response, body) {
    castaneum.createDocument(response, function(document, sizzle) {
      var postHeaderElements = sizzle(".entry > h2");
      test.notEqual(postHeaderElements.length, 0);
      test.done();
    });
  });
};
